/*
 * camera.c
 *
 *  Created on: 09.apr.2010
 *      Author: Cato
 */

#include "camera.h"

//Variables and configurations
//Exposure change calue = 200;
//Exposure = 0x09xxxx - default 0x0907c0
unsigned int LUT_DATA_CFG[25] = {0x000000,0x20c000,0x0907c0,0x050000,0x060019,
		0x0A8000,0x2B000b,0x2C000f,0x2D000f,0x2E000b,0x100051,0x111801,0x120003,
		0x100053,0x980000,0xA00000,0xA10000,
		0xA20FFF,0x010036,0x020010,0x03077F,0x0409FF,0x220011,0x230011,0x4901A8};

unsigned int index_array[25];
unsigned int counter_index;

void camera_init()
{

}

void camera_config(void)
{
	switch(IORD_ALTERA_AVALON_PIO_DATA(LUT_INDEX_BASE)-1)
	{

		case(0):
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LUT_DATA_BASE,LUT_DATA_CFG[0]);
			break;
		}
		case(1):
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LUT_DATA_BASE,LUT_DATA_CFG[1]);
			break;
		}
		case(2):
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LUT_DATA_BASE,LUT_DATA_CFG[2]);
			break;
		}
		case(3):
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LUT_DATA_BASE,LUT_DATA_CFG[3]);
			break;
		}
		case(4):
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LUT_DATA_BASE,LUT_DATA_CFG[4]);
			break;
		}
		case(5):
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LUT_DATA_BASE,LUT_DATA_CFG[5]);
			break;
		}
		case(6):
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LUT_DATA_BASE,LUT_DATA_CFG[6]);
			break;
		}
		case(7):
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LUT_DATA_BASE,LUT_DATA_CFG[7]);
			break;
		}
		case(8):
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LUT_DATA_BASE,LUT_DATA_CFG[8]);
			break;
		}
		case(9):
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LUT_DATA_BASE,LUT_DATA_CFG[9]);
			break;
		}
		case(10):
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LUT_DATA_BASE,LUT_DATA_CFG[10]);
			break;
		}
		case(11):
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LUT_DATA_BASE,LUT_DATA_CFG[11]);
			break;
		}
		case(12):
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LUT_DATA_BASE,LUT_DATA_CFG[12]);
			break;
		}
		case(13):
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LUT_DATA_BASE,LUT_DATA_CFG[13]);
			break;
		}
		case(14):
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LUT_DATA_BASE,LUT_DATA_CFG[14]);
			break;
		}
		case(15):
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LUT_DATA_BASE,LUT_DATA_CFG[15]);
			break;
		}
		case(16):
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LUT_DATA_BASE,LUT_DATA_CFG[16]);
			break;
		}
		case(17):
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LUT_DATA_BASE,LUT_DATA_CFG[17]);
			break;
		}
		case(18):
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LUT_DATA_BASE,LUT_DATA_CFG[18]);
			break;
		}
		case(19):
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LUT_DATA_BASE,LUT_DATA_CFG[19]);
			break;
		}
		case(20):
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LUT_DATA_BASE,LUT_DATA_CFG[20]);
			break;
		}
		case(21):
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LUT_DATA_BASE,LUT_DATA_CFG[21]);
			break;
		}
		case(22):
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LUT_DATA_BASE,LUT_DATA_CFG[22]);
			break;
		}
		case(23):
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LUT_DATA_BASE,LUT_DATA_CFG[23]);
			break;
		}
		case(24):
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LUT_DATA_BASE,LUT_DATA_CFG[24]);
			break;
		}
		default:
		{
			IOWR_ALTERA_AVALON_PIO_DATA(LUT_DATA_BASE,0x000000);
			break;
		}
	}
}

void set_LUT_DATA_CFG_array(int index,int value)
{
	LUT_DATA_CFG[index] = value;
}

unsigned int get_LUT_DATA_CFG_array(int index)
{
	return LUT_DATA_CFG[index];
}


