/*
 * timer.c
 *
 *  Created on: 09.apr.2010
 *      Author: Cato
 */

#include "timer.h"

//Variables


void timer_init()
{
	//	This part activates the counter interrupt and links it to counter_isr()

	//Setting the period of the timer -> PERIODL AND PERIODH (16bit+16bit) gives PERIOD (32bit)
	IOWR(TIMER_0_BASE, ALTERA_AVALON_TIMER_PERIODL_REG, 0xFFFF);
	//Same as above
	IOWR(TIMER_0_BASE, ALTERA_AVALON_TIMER_PERIODH_REG, 0x00FF);
	//Setting START, CONT and ITO to "1" in the control register
	IOWR_ALTERA_AVALON_TIMER_CONTROL(TIMER_0_BASE, 0x07);

}


