% Demosaic interpolation
% by Marwell
% 2010

%%
% Nearest neighbor as in original RAW2RGB module:

close all;
clear all;

I = imread('RAW_CANON_450D_cropped.pgm');
size(I)
[row_size,column_size] = size (I);
figure(1);
imshow(I);

J = demosaic(I,'rggb');
size(J)
%figure, imshow(J);
% figure(2);
% subplot(2,2,1),image(J),title('RGB version');
% subplot(2,2,2),imshow(J(:,:,1)),title('Red channel');
% subplot(2,2,3),imshow(J(:,:,2)),title('Green Channel');
% subplot(2,2,4),imshow(J(:,:,3)),title('Blue Channel');
figure(2);
image(J),title('RGB version using Matlab demosaic');

% W = uint16(zeros(row_size/2,column_size/2,3));
% size(W)

%demosaic nearneig - assuming sensor arrangement='bggr'(same as camera):
%begin
% close all;
% clear all;
% 
% I = uint8([15 20 15 20;40 10 40 10;15 20 15 20;40 10 40 10]);
% [row_size,column_size] = size (I);
% imshow(I);
% % 
% W = uint16(zeros(row_size/2,column_size/2,3));
% size(W)
% 
% 
% for y = 1:1:row_size,
%     y_bin = dec2bin(y-1);
%     if(y_bin(length(y_bin))=='0')
% %         disp('Start1');
%         for x = column_size:-1:1,
%             x_bin = dec2bin(x);
%             if(x_bin(length(x_bin))=='0')
% %                 disp('Start2');
%                 W((y+1)/2,x/2,1) = I(y+1,x); %Red mDATA_1
% %                 disp('R');
%                 if(x==column_size)
%                     W((y+1)/2,x/2,2) = (I(y,x)+I(y,1))/2; %Green when at start
% %                     disp('G start');
%                 else
%                     W((y+1)/2,x/2,2) = (I(y,x)/2+I(y+1,x+1)/2); %Green else
% %                     disp('G else');
%                 end
%             
%                 if(x==column_size && y == 1)
%                     W((y+1)/2,x/2,3) = 0; %Blue when in upper left corner
%                      disp('B start corner');
%                 elseif(x==column_size)
%                     W((y+1)/2,x/2,3) = I(y+1,1); %Blue else when at start
% %                     disp('B else start');
%                 else
%                     W((y+1)/2,x/2,3) = I(y,x+1); %Blue else
% %                     disp('B else');
%                 end
% 
%             end
%         end
%     end
% 
% 
% end
% 
% 
% %end
% W = uint8(W);
% figure, image(W);


%%


%demosaic nearneig assuming sensor arrangement='rggb' (same as on the Canon 450D):
%Its the same algoritm as above, I just altered which channel X in W(.,.,X)
%the data where saved to.
%begin
% close all;
% clear all;
% 
%  I = uint8([15 20 15 20;40 10 40 10;15 20 15 20;40 10 40 10]);
%  [row_size,column_size] = size (I);
%  imshow(I);

W = uint16(zeros(row_size/2,column_size/2,3));
size(W)


for y = 1:1:row_size,
    y_bin = dec2bin(y-1);
    if(y_bin(length(y_bin))=='0')
%         disp('Start1');
        for x = column_size:-1:1,
            x_bin = dec2bin(x);
            if(x_bin(length(x_bin))=='0')
%                 disp('Start2');
                W((y+1)/2,x/2,3) = I(y+1,x); %Blue mDATA_1
%                 disp('B');
                if(x==column_size)
                    W((y+1)/2,x/2,2) = (I(y,x)/2+I(y,1)/2); %Green when at start. Divides the two values by two _before_ adding instead of after to prevent overflow
%                     disp('G start');
                else
                    W((y+1)/2,x/2,2) = (uint16(I(y,x))+uint16(I(y+1,x+1)))/2; %Green else converting to a higher uint resolution also helps
%                     disp('G else');
                end
            
                if(x==column_size && y == 1)
                    W((y+1)/2,x/2,1) = 0; %Red when in upper left corner
                     disp('R start corner');
                elseif(x==column_size)
                    W((y+1)/2,x/2,1) = I(y+1,1); %Red else when at start
%                     disp('R else start');
                else
                    W((y+1)/2,x/2,1) = I(y,x+1); %Red else
%                     disp('R else');
                end

            end
        end
    end


end


%end

% figure, image(W);
% figure(3);
% W = uint8(W);
% subplot(2,2,1),image(W),title('RGB version');
% subplot(2,2,2),imshow(W(:,:,1)),title('Red channel');
% subplot(2,2,3),imshow(W(:,:,2)),title('Green Channel');
% subplot(2,2,4),imshow(W(:,:,3)),title('Blue Channel');

figure(3);
W = uint8(W);
image(W),title('RGB version using RAW2RGB demosaic');

%%


